DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Private Attributes | List of all members
FGFrameContent Class Reference

Class representing the "Frame Content" Functional Group Macro. More...

Inheritance diagram for FGFrameContent:

## Public Member Functions
| FGFrameContent ()
| Constructor, creates empty functional group.
virtual | ~FGFrameContent ()
| Virtual destructor.
virtual FGBase * | clone () const
| Returns a deep copy of this object. More...
virtual DcmFGTypes::E_FGSharedType | getSharedType () const
| Returns shared functional group type (always "per-frame") More...
virtual void | clearData ()
| Clear all data.
virtual OFCondition | check () const
| Check whether the current content of this group is consistent and complete. More...
virtual OFCondition | read (DcmItem &item)
| Read Frame Content Sequence from given item. More...
virtual OFCondition | write (DcmItem &item)
| Writes the content of this class into Frame Content Sequence (newly created) into given item. More...
virtual int | compare (const FGBase &rhs) const
| Comparison operator that compares the normalized value of this object with a given object of the same type, i.e. the elements within both functional groups (this and rhs parameter) are compared by value! Both objects (this and rhs) need to have the same type (i.e. both FGUnknown) to be comparable. More...
virtual OFCondition | getFrameAcquisitionNumber (Uint16 &value, const unsigned long pos=0)
| Get Frame Acquisition Number. More...
virtual OFCondition | getFrameReferenceDateTime (OFString &value, const signed long pos=0)
| Get Frame Reference Date Time. More...
virtual OFCondition | getFrameAcquisitionDateTime (OFString &value, const signed long pos=0)
| Get Frame Acquisition Date Time. More...
virtual OFCondition | getFrameAcquisitionDuration (Float64 &value, const unsigned long pos=0)
| Get Frame Acquisition Duration. More...
virtual OFCondition | getCardiacCyclePosition (OFString &value, const signed long pos=0)
| Get Cardiac Cycle Position. More...
virtual OFCondition | getRespiratoryCyclePosition (OFString &value, const signed long pos=0)
| Get Respiratory Cycle Position. More...
virtual OFCondition | getDimensionIndexValues (Uint32 &value, const unsigned long pos=0)
| Get Dimension Index Value. More...
virtual OFCondition | getTemporalPositionIndex (Uint32 &value, const unsigned long pos=0)
| Get Temporal Position Index. More...
virtual OFCondition | getStackID (OFString &value, const signed long pos=0)
| Get Stack ID. More...
virtual OFCondition | getInStackPositionNumber (Uint32 &value, const unsigned long pos=0)
| Get In-Stack Position Number. More...
virtual OFCondition | getFrameComments (OFString &value, const signed long pos=0)
| Get Frame Comments. More...
virtual OFCondition | getFrameLabel (OFString &value, const signed long pos=0)
| Get Frame Label. More...
virtual OFCondition | setFrameAcquisitionNumber (const Uint16 &value, const OFBool checkValue=OFTrue)
| Set Frame Acquisition Number. More...
virtual OFCondition | setFrameReferenceDateTime (const OFString &value, const OFBool checkValue=OFTrue)
| Set Frame Frame Reference Date Time. More...
virtual OFCondition | setFrameAcquisitionDateTime (const OFString &value, const OFBool checkValue=OFTrue)
| Set Frame Acquisition Date Time. More...
virtual OFCondition | setFrameAcquisitionDuration (const Float64 &value, const OFBool checkValue=OFTrue)
| Set Frame Acquisition Duration. More...
virtual OFCondition | setCardiacCyclePosition (const OFString &value, const OFBool checkValue=OFTrue)
| Set Cardiac Cycle Position. More...
virtual OFCondition | setRespiratoryCyclePosition (const OFString &value, const OFBool checkValue=OFTrue)
| Set Respiratory Cycle Position. More...
virtual OFCondition | setDimensionIndexValues (const Uint32 &value, const unsigned int dim, const OFBool checkValue=OFTrue)
| Set one of the Dimension Index Values. More...
virtual OFCondition | setTemporalPositionIndex (const Uint32 &value, const OFBool checkValue=OFTrue)
| Set Temporal Position Index. More...
virtual OFCondition | setStackID (const OFString &value, const OFBool checkValue=OFTrue)
| Set Stack ID. More...
virtual OFCondition | setInStackPositionNumber (const Uint32 &value, const OFBool checkValue=OFTrue)
| Set In-Stack Position Number. More...
virtual OFCondition | setFrameComments (const OFString &value, const OFBool checkValue=OFTrue)
| Set Frame Comments. More...
virtual OFCondition | setFrameLabel (const OFString &value, const OFBool checkValue=OFTrue)
| Set Frame Label. More...
Public Member Functions inherited from FGBase
| FGBase (const DcmFGTypes::E_FGType fgType)
| Constructor, creates new functional group of given type. More...
virtual DcmFGTypes::E_FGType | getType () const
| Return the type of this functional group. More...
virtual | ~FGBase ()
| Virtual destructor.

## Private Attributes
DcmUnsignedShort | m_FrameAcquisitonNumber
| Frame Acquisition Number (US, VM 1, Required type 3)
DcmDateTime | m_FrameReferenceDateTime
| Frame Reference DateTime (DT, 1, 1C)
DcmDateTime | m_FrameAcquisitionDateTime
| Frame Acquisition DateTime (DT, 1, 1C)
DcmFloatingPointDouble | m_FrameAcquisitionDuration
| Frame Acquisition Duration (FD, 1, 1C)
DcmCodeString | m_CardiacCyclePosition
| Cardiac Cycle Position (CS, 1, 3)
DcmCodeString | m_RespiratoryCyclePosition
| Respiratory Cycle Position (CS, 1, 3)
DcmUnsignedLong | m_DimensionIndexValues
| Dimension Index Values (UL, 1-n, 1C)
DcmUnsignedLong | m_TemporalPositionIndex
| Temporal Position Index (UL, 1, 1C)
DcmShortString | m_StackID
| Stack ID (SH, 1, 1C)
DcmUnsignedLong | m_InStackPositionNumber
| In-Stack Position Number (UL, 1, 1C)
DcmLongText | m_FrameComments
| Frame Comments (LT, 1, 3)
DcmLongString | m_FrameLabel
| Frame Label (LO, 1, 3)

## Additional Inherited Members
Protected Member Functions inherited from FGBase
virtual OFCondition | getItemFromFGSequence (DcmItem &source, const DcmTagKey &seqKey, const unsigned long itemNum, DcmItem *&result)
| Get the item containing the payload of a functional group sequence, identified by the functional group's sequence key provided and the desired item number. More...
virtual OFCondition | getNumItemsFromFGSequence (DcmItem &source, const DcmTagKey &seqKey, unsigned long &result)
| Get number of items in a functional group sequence, identified by the functional group's sequence key. More...
virtual OFCondition | createNewFGSequence (DcmItem &destination, const DcmTagKey &seqKey, const unsigned long numItems, DcmItem *&firstItem)
| Create functional group sequence specified by given sequence tag key. More...

## Detailed Description

Class representing the "Frame Content" Functional Group Macro.

Can only be used as per-frame functional group (never shared).

## Member Function Documentation

## ◆ check()

virtual OFCondition FGFrameContent::check | ( |  | ) | const
| virtual

Check whether the current content of this group is consistent and complete.

Returns
  EC_Normal, if no errors are found, error otherwise

Implements FGBase.

## ◆ clone()

virtual FGBase* FGFrameContent::clone | ( |  | ) | const
| virtual

Returns a deep copy of this object.

Returns
  Deep copy of this object

Implements FGBase.

## ◆ compare()

virtual int FGFrameContent::compare | ( | const FGBase & | rhs | ) | const
| virtual

Comparison operator that compares the normalized value of this object with a given object of the same type, i.e. the elements within both functional groups (this and rhs parameter) are compared by value! Both objects (this and rhs) need to have the same type (i.e. both FGUnknown) to be comparable.

This function is used in order to decide whether a functional group already exists, or is new. This is used in particular to find out whether a given functional group can be shared (i.e. the same information already exists as shared functional group) or is different from the same shared group. In that case the shared functional group must be distributed into per-frame functional groups, instead. The exact implementation for implementing the comparison is not relevant. However, it must be a comparison by value.

Parameters

  rhs | the right hand side of the comparison

Returns
  0 if the object values are equal. -1 if either the value of the first component that does not match is lower in the this object, or all compared components match but this component is shorter. Also returned if this type and rhs type (DcmFGTypes::E_FGType) do not match. 1 if either the value of the first component that does not match is greater in this object, or all compared components match but this component is longer.

Implements FGBase.

## ◆ getCardiacCyclePosition()

virtual OFCondition FGFrameContent::getCardiacCyclePosition | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  |
| virtual

Get Cardiac Cycle Position.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getDimensionIndexValues()

virtual OFCondition FGFrameContent::getDimensionIndexValues | ( | Uint32 & | value,
|  | const unsigned long | pos = `0`
| ) |  |
| virtual

Get Dimension Index Value.

Parameters

  value | Reference to variable that should hold the result
  pos | Position of the value inside the DICOM element. If 0, the first value is returned. If the no value at the given position exists, an error is returned.

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getFrameAcquisitionDateTime()

virtual OFCondition FGFrameContent::getFrameAcquisitionDateTime | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  |
| virtual

Get Frame Acquisition Date Time.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getFrameAcquisitionDuration()

virtual OFCondition FGFrameContent::getFrameAcquisitionDuration | ( | Float64 & | value,
|  | const unsigned long | pos = `0`
| ) |  |
| virtual

Get Frame Acquisition Duration.

Parameters

  value | Reference to variable that should hold the result
  pos | Position of the value inside the DICOM element. If 0, the first value is returned. If the no value at the given position exists, an error is returned.

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getFrameAcquisitionNumber()

virtual OFCondition FGFrameContent::getFrameAcquisitionNumber | ( | Uint16 & | value,
|  | const unsigned long | pos = `0`
| ) |  |
| virtual

Get Frame Acquisition Number.

Parameters

  value | Reference to variable that should hold the result
  pos | Position of the value inside the DICOM element. If 0, the first value is returned. If the no value at the given position exists, an error is returned.

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getFrameComments()

virtual OFCondition FGFrameContent::getFrameComments | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  |
| virtual

Get Frame Comments.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getFrameLabel()

virtual OFCondition FGFrameContent::getFrameLabel | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  |
| virtual

Get Frame Label.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getFrameReferenceDateTime()

virtual OFCondition FGFrameContent::getFrameReferenceDateTime | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  |
| virtual

Get Frame Reference Date Time.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getInStackPositionNumber()

virtual OFCondition FGFrameContent::getInStackPositionNumber | ( | Uint32 & | value,
|  | const unsigned long | pos = `0`
| ) |  |
| virtual

Get In-Stack Position Number.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getRespiratoryCyclePosition()

virtual OFCondition FGFrameContent::getRespiratoryCyclePosition | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  |
| virtual

Get Respiratory Cycle Position.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getSharedType()

virtual DcmFGTypes::E_FGSharedType FGFrameContent::getSharedType | ( |  | ) | const
| inline virtual

Returns shared functional group type (always "per-frame")

Returns
  The functional group type (DcmFGTypes::EFGS_ONLYPERFRAME)

Implements FGBase.

References DcmFGTypes::EFGS_ONLYPERFRAME.

## ◆ getStackID()

virtual OFCondition FGFrameContent::getStackID | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  |
| virtual

Get Stack ID.

Parameters

  value | Reference to variable that should hold the result
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ getTemporalPositionIndex()

virtual OFCondition FGFrameContent::getTemporalPositionIndex | ( | Uint32 & | value,
|  | const unsigned long | pos = `0`
| ) |  |
| virtual

Get Temporal Position Index.

Parameters

  value | Reference to variable that should hold the result
  pos | Position of the value inside the DICOM element. If 0, the first value is returned. If the no value at the given position exists, an error is returned.

Returns
  EC_Normal, if value could be returned, error otherwise

## ◆ read()

virtual OFCondition FGFrameContent::read | ( | DcmItem & | item | ) |
| virtual

Read Frame Content Sequence from given item.

Parameters

  item | The item to read from

Returns
  EC_Normal if reading was successful, error otherwise

Implements FGBase.

## ◆ setCardiacCyclePosition()

virtual OFCondition FGFrameContent::setCardiacCyclePosition | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Cardiac Cycle Position.

Parameters

  value | Value that should be set
  checkValue | If OFTrue, basic checks are performed whether the value is valid for this attribute

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setDimensionIndexValues()

virtual OFCondition FGFrameContent::setDimensionIndexValues | ( | const Uint32 & | value,
|  | const unsigned int | dim,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set one of the Dimension Index Values.

Parameters

  value | Value that should be set (lowest index starts with 1)
  dim | The position of the value that should be set (lowest index starts with 0), i.e. select the 1st, 2nd, ..nth dimension
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setFrameAcquisitionDateTime()

virtual OFCondition FGFrameContent::setFrameAcquisitionDateTime | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Frame Acquisition Date Time.

Parameters

  value | Value that should be set
  checkValue | If OFTrue, basic checks are performed whether the value is valid for this attribute

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setFrameAcquisitionDuration()

virtual OFCondition FGFrameContent::setFrameAcquisitionDuration | ( | const Float64 & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Frame Acquisition Duration.

Parameters

  value | Value that should be set
  checkValue | If OFTrue, basic checks are performed whether the value is valid for this attribute

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setFrameAcquisitionNumber()

virtual OFCondition FGFrameContent::setFrameAcquisitionNumber | ( | const Uint16 & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Frame Acquisition Number.

Parameters

  value | Value that should be set
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setFrameComments()

virtual OFCondition FGFrameContent::setFrameComments | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Frame Comments.

Parameters

  value | Value that should be set
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setFrameLabel()

virtual OFCondition FGFrameContent::setFrameLabel | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Frame Label.

Parameters

  value | Value that should be set
  checkValue | If OFTrue, basic checks are performed whether the value is valid for this attribute

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setFrameReferenceDateTime()

virtual OFCondition FGFrameContent::setFrameReferenceDateTime | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Frame Frame Reference Date Time.

Parameters

  value | Value that should be set
  checkValue | If OFTrue, basic checks are performed whether the value is valid for this attribute

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setInStackPositionNumber()

virtual OFCondition FGFrameContent::setInStackPositionNumber | ( | const Uint32 & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set In-Stack Position Number.

Parameters

  value | Value that should be set
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setRespiratoryCyclePosition()

virtual OFCondition FGFrameContent::setRespiratoryCyclePosition | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Respiratory Cycle Position.

Parameters

  value | Value that should be set
  checkValue | If OFTrue, basic checks are performed whether the value is valid for this attribute

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setStackID()

virtual OFCondition FGFrameContent::setStackID | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Stack ID.

Parameters

  value | Value that should be set
  checkValue | If OFTrue, basic checks are performed whether the value is valid for this attribute

Returns
  EC_Normal, if value was set, error otherwise

## ◆ setTemporalPositionIndex()

virtual OFCondition FGFrameContent::setTemporalPositionIndex | ( | const Uint32 & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Temporal Position Index.

Parameters

  value | Value that should be set
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal, if value was set, error otherwise

## ◆ write()

virtual OFCondition FGFrameContent::write | ( | DcmItem & | item | ) |
| virtual

Writes the content of this class into Frame Content Sequence (newly created) into given item.

Parameters

  item | The item to write to

Returns
  EC_Normal if writing was successful, error otherwise

Implements FGBase.

The documentation for this class was generated from the following file:

- dcmfg/include/dcmtk/dcmfg/fgfracon.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1